;;;; syntax.scm


(define-macro (make spec . argv)
  (let ([make (lambda (spec argv)
		(let ([form-error (lambda (s . p) (apply error s spec p))])
		  (and (or (list? spec) (form-error "illegal specification (not a sequence)"))
		       (or (pair? spec) (form-error "empty specification"))
		       (andmap
			(lambda (line)
			  (and (or (and (list? line) (>= (length line) 2))
				   (form-error "clause does not have at least 2 parts" line))
			       (let ([name (car line)])
				 (or (list? (cadr line))
				     (make:line-error "second part of clause is not a sequence" (cadr line))))))
			spec))
		  `(make/proc (list ,@(map (lambda (line)
					     `(list ,(car line)
						    (list ,@(cadr line))
						    ,@(let ([l (cddr line)])
							(if (null? l)
							    '()
							    `((lambda ()
								,@l))))))
					   spec))
			      ,(if (vector? argv) `',argv (car argv)))))])
    (if (pair? argv)
	(make spec argv)
	(make spec '#())) ) )
